//index.js
//获取应用实例
const app = getApp()
Page({
  data: {
    motto: 'Demo',
    userInfo: {},
    canIUse: wx.canIUse('button.open-type.getUserInfo'),
    syetemInfo: ''
  },
  //事件处理函数
  bindViewTapToLiver: function () {
    wx.navigateTo({
      url: '../liver/liver'
    })
  },
  bindViewTapToPusher: function () {
    wx.navigateTo({
      url: '../pusher/pusher'
    })
  },
  bindViewTapToAudio: function () {
    wx.navigateTo({
      url: '../audio/audio'
    })
  },
  bindViewTapToVideo: function () {
    wx.navigateTo({
      url: '../video/video'
    })
  },
  bindViewTapToPusherAndLiver: function() {
    wx.navigateTo({
      url: '../pushAndlive/pushAndlive'
    })
  },
  bindViewTapToChangeConfig: () => {
    wx.navigateTo({
      url: '../config/change'
    })
  },
  onLoad: function () {
    // 更改全局配置
    var ip = wx.getStorageSync('ip');
    var minBitrate = wx.getStorageSync('minBitrate');
    var maxBitrate = wx.getStorageSync('maxBitrate');
    var minCache = wx.getStorageSync('minCache');
    var maxCache = wx.getStorageSync('maxCache');

    if (ip) {
      app.globalData.pusherUrl = `rtmp://${ip}:1935/rtc/push/harry`;
      app.globalData.liverUrl = `rtmp://${ip}:1935/rtc/pull/harry`;
    }
    if (minBitrate !=='' && minBitrate >= 0) {
      app.globalData.minBitrate = minBitrate;
    }
    if (maxBitrate !=='' && maxBitrate >= 0) {
      app.globalData.maxBitrate = maxBitrate;
    }
    if (minCache !=='' && minCache >= 0) {
      app.globalData.minCache = minCache;
    }
    if (maxCache !=='' && maxCache >= 0) {
      app.globalData.maxCache = maxCache;
    }
    try {
      const res = wx.getSystemInfoSync()
      this.setData({
        systemInfo: res
      });
    } catch (e) {
      // Do something when catch error
    }
    if (app.globalData.userInfo) {
      this.setData({
        userInfo: app.globalData.userInfo,
      })
    } else if (this.data.canIUse) {
      // 由于 getUserInfo 是网络请求，可能会在 Page.onLoad 之后才返回
      // 所以此处加入 callback 以防止这种情况
      app.userInfoReadyCallback = res => {
        this.setData({
          userInfo: res.userInfo,
        })
      }
    } else {
      // 在没有 open-type=getUserInfo 版本的兼容处理
      wx.getUserInfo({
        success: res => {
          app.globalData.userInfo = res.userInfo
          this.setData({
            userInfo: res.userInfo,
          })
        }
      })
    }
  },
  getUserInfo: function (e) {
    console.log(e)
    app.globalData.userInfo = e.detail.userInfo
    this.setData({
      userInfo: e.detail.userInfo,
      hasUserInfo: true
    })
  }
})