// pages/config/change.js
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    bizName: 'demo',
    appId: 'default',
    workspaceId: 'default',
    uid: '',
    ip: '',
    sign: 'signature',
    lastContent: '使用上次内容',
    index: 0,
    serverArr: [
      'wss://mrtc.mpaas.cn-hangzhou.aliyuncs.com/ws',
      'wss://room.mrtc-fin.cn-shanghai.aliyuncs.com/ws',
      'wss://artvcroom.alipay.com/ws'
    ],
    serverNameArr: [
      "mpaas非金prod",
      "mpaas金区prod",
      "主站prod"
    ]
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    var uid = `wx_${(new Date()).valueOf()}`;
    var minBitrate = wx.getStorageSync('minBitrate');
    var maxBitrate = wx.getStorageSync('maxBitrate');
    var minCache = wx.getStorageSync('minCache');
    var maxCache = wx.getStorageSync('maxCache');
    let server_index = wx.getStorageSync("serverIndex")
    var server_url = 'wss://mrtc.mpaas.cn-hangzhou.aliyuncs.com/ws';

    this.setData({
      uid,
      minBitrate,
      maxBitrate,
      minCache,
      maxCache,
      server_url
    });
    
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    var uid = `wx_${(new Date()).valueOf()}`;
    this.setData({
      uid: uid
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  // 本SDK使用到了websocket，如果业务层如果也有使用需要，请参考以下例子，避免冲突
  privateSocketTask(){
    let socketTask = wx.connectSocket({
      url: "wss://mrtc.mpaas.cn-hangzhou.aliyuncs.com/ws",
      header: {
        'content-type': 'application/json'
      },
      method: 'post',
      timeout: 5000,
      success: res => {
        console.log(`业务层websocket连接test 连接成功 res=${JSON.stringify(res)}`);
      },
      fail: err => {
        console.error(`业务层websocket连接test 连接失败 err=${err}`)
      }
      });
      socketTask.onOpen(function (res) {
        console.log(`业务层websocket连接test onOpen res=${res}`)
      });
      socketTask.onMessage(function (res) {
        console.log(`业务层websocket连接test onMessage res=${res}`)
      });
      socketTask.onError(function (res) {
        console.error(`业务层websocket连接test onError res=${res}`)
      });
      socketTask.onClose(function (res) {
        console.log(`业务层websocket连接test onClose res=${res}`)
      });
 },
  bindPickerChange: function (e) {
    const index = e.detail.value;
    console.log('picker发送选择改变，携带值为', index);
    let serverUrl = this.data.serverArr[index];
    this.setData({
      index: index,
      server_url: serverUrl
    })

  },
  getLastContent() {
    var bizName = wx.getStorageSync('bizName');
    var uid = wx.getStorageSync('uid');
    var appId = wx.getStorageSync('appId');
    var workspaceId = wx.getStorageSync('workspaceId');
    var sign = wx.getStorageSync('sign');
    var index = wx.getStorageSync('serverIndex');
    if (this.data.lastContent == '使用上次内容') {
      this.setData({
        lastContent: '使用默认',
        bizName,
        appId,
        workspaceId,
        uid,
        sign,
        index,
        server_url: this.data.serverArr[index]
      })
    } else {
      this.setData({
        lastContent: '使用上次内容',
        bizName: 'demo',
        appId: 'default',
        workspaceId: 'default',
        sign: 'signature',
        index: 0,
        uid: `wx_${(new Date()).valueOf()}`,
        server_url: this.data.serverArr[0]
      })
    }

  },
  formSubmit(e) {
    console.log('form发生了submit事件，携带数据为：', e.detail.value)
    const {
      detail = {}
    } = e;
    const {
      value = {}
    } = detail;
    const {
      bizName,
      appId,
      workspaceId,
      uid,
      sign,
      minBitrate,
      maxBitrate,
      minCache,
      maxCache
    } = value;
    /*  if (ip) {
       getApp().globalData.pusherUrl = `rtmp://${ip}:1935/rtc/push/harry`;
       getApp().globalData.liverUrl = `rtmp://${ip}:1935/rtc/pull/harry`;
       wx.setStorageSync('ip', ip);
     } */

    wx.setStorageSync('serverIndex', this.data.index);
    app.globalData.server_url = this.data.server_url
    if (bizName) {
      app.globalData.bizName = bizName;
      wx.setStorageSync('bizName', bizName);
    }

    if (appId) {
      app.globalData.appId = appId;
      wx.setStorageSync('appId', appId);
    }

    if (workspaceId) {
      app.globalData.workspaceId = workspaceId;
      wx.setStorageSync('workspaceId', workspaceId);
    }
    if (uid) {
      app.globalData.uid = uid;
      wx.setStorageSync('uid', uid);
    }

    if (sign) {
      app.globalData.sign = sign;
      wx.setStorageSync('sign', sign);
    }

    if (typeof minBitrate !== 'undefined') {
      getApp().globalData.minBitrate = minBitrate;
      wx.setStorageSync('minBitrate', minBitrate);
    }
    if (typeof maxBitrate !== 'undefined') {
      getApp().globalData.maxBitrate = maxBitrate;
      wx.setStorageSync('maxBitrate', maxBitrate);
    }
    if (typeof minCache !== 'undefined') {
      getApp().globalData.minCache = minCache;
      wx.setStorageSync('minCache', minCache);
    }
    if (typeof maxCache !== 'undefined') {
      getApp().globalData.maxCache = maxCache;
      wx.setStorageSync('maxCache', maxCache);
    }
    wx.navigateTo({
      url: '../room/room'
    })
  },



  formReset(e) {
    console.log('form发生了reset事件，携带数据为：', e.detail.value)
    this.setData({
      chosen: ''
    })
  }
})