const app = getApp()
// pages/pushAndlive/pushAndlive.js
Page({
  /**
   * 页面的初始数据
   */
  data: {
    showMedia:false,
    pushURL: app.globalData.pushURL,
    liveURL: app.globalData.liveUrl,
    feedIds: app.globalData.feedIds,
    minBitrate: app.globalData.minBitrate,
    maxBitrate: app.globalData.maxBitrate,
    minCache: app.globalData.minCache,
    maxCache: app.globalData.maxCache,
    enableCamera: true,
    soundMode: "speaker",
    muted: true,
    roomId: app.globalData.roomId,
    rtoken: app.globalData.rtoken,
    cameraScore: '',
    micScore: '',
    cameraText: '',
    micText: '',
    listData: { pusher: {}, player: {} },
    chatMessage: '',
    chatRecord: [],
    showChat: false,
    _uid: '',
    inviteId: "",
    inviteRes: ""
  },
  toggleSoundMode() {
    this.setData({
      soundMode: this.data.soundMode == 'ear' ? "speaker" : "ear"
    });
    if (this.data.soundMode == "ear") {
      app.globalData.artvcChat.ReportClientEvent(329)
    } else {
      app.globalData.artvcChat.ReportClientEvent(330)
    }

  },
  // 发送文本消息
  sendMessage() {
    let uids = [];
    for (let i = 0; i < this.data.feedIds.length; i++) {
      uids.push(this.data.feedIds[i].uid)
    }
    let timestamp = Date.now();
    app.globalData.artvcChat.SendTxtMessage({ uids, timestamp, msg: this.data.chatMessage });
  },
  getMessageContent(e) {
    this.setData({
      chatMessage: e.detail.value
    })
  },
  //邀请对方
  sendInvite(e) {
    console.log(this.data.inviteId);
    app.globalData.artvcChat.SendInvite(this.data.inviteId)
  },
  getInviteUser(e) {
    this.setData({
      inviteId: e.detail.value
    })
  },
  //发布推流状态变更监听
  statechangePublish(e) {
    app.globalData.artvcChat.statechangePublish(e)
  },

  //发布网络变更监听
  pusherbindnetstatus(e) {
    let pusher = app.globalData.artvcChat.pusherbindnetstatus(e)
    this.setData({
      "listData.pusher": pusher
    });
  },
  OnSendTxtMessageSucc(msgId) {
    let { chatMessage, chatRecord } = this.data;
    let obj = {};
    obj.msg = chatMessage;
    obj.myMessage = true;
    obj.uid = this.data._uid;
    chatRecord.push(obj);
    this.setData({
      chatMessage: '',
      chatRecord
    })
  },
  OnInviteSucc() {
    this.setData({
      inviteRes: "邀请成功"
    });
  },
  OnInviteFail(code, msg) {
    this.setData({
      inviteRes: "邀请失败:" + msg
    })
  },

  //发布推流错误状态变更监听
  pusherbinderror(e) {
    app.globalData.artvcChat.pusherbinderror(e);
    const _that = this;
    const errcode = e.detail.errCode;
    const errmsg = e.detail.errMsg;
    wx.showModal({
      title: '系统提示',
      content: errcode + ': ' + errmsg,
      confirmText: '确认',
      showCancel: false,
      success: (res) => {
        if (errcode == -1307) {
          _that.pusherCtx.stop({
            success: res => {
              app.globalData.artvcChat.trace("[pushAndLive] pusher error stop");
              _that.pusherCtx.start({
                success: res => {
                  app.globalData.artvcChat.trace("[pushAndLive] pusher error restart");
                }
              })
            }
          })
        }
      }
    })
  },
  //订阅拉流状态变更监听
  statechangeSubscribe(e) {
    app.globalData.artvcChat.statechangeSubscribe(e);
  },

  //订阅拉流网络状态变更监听
  playerbindnetstatus(e) {
    let obj = app.globalData.artvcChat.playerbindnetstatus(e);
    let listDatas = {}
    if (this.data.listData) {
      listDatas = this.data.listData;
    }
    let player = this.data.listData.player;
    player[e.currentTarget.dataset.feedid] = obj;
    this.setData({
      "listData.player": player,
    });
  },

  //订阅拉流错误状态变更监听
  playerbinderror(e) {
    const errcode = e.detail.errCode;
    const errmsg = e.detail.errMsg;
    app.globalData.artvcChat.trace(`[pushAndLive] subscribe playerbinderror code:${errcode},msg:${errmsg}`);
  },


  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    app.globalData.artvcChat.trace("[pushAndLive] onLoad");
    this.liverCtx = {};
    //回调接口注册
    app.globalData.artvcChat.OnPublish = this.OnPublish;
    app.globalData.artvcChat.OnSubscribe = this.OnSubscribe;
    app.globalData.artvcChat.OnGetSign = this.OnGetSign;
    app.globalData.artvcChat.OnLeaveRoom = this.OnLeaveRoom;
    app.globalData.artvcChat.OnParticipantLeaveRoom = this.OnParticipantLeaveRoom;
    app.globalData.artvcChat.OnClientJoin = this.OnClientJoin;
    app.globalData.artvcChat.OnSendTxtMessageSucc = this.OnSendTxtMessageSucc;
    app.globalData.artvcChat.OnGetTxtMessage = this.OnGetTxtMessage;
    app.globalData.artvcChat.OnUnPublish = this.OnUnPublish;
    app.globalData.artvcChat.OnUnsubscribe = this.OnUnsubscribe;
    app.globalData.artvcChat.OnInviteSucc = this.OnInviteSucc;
    app.globalData.artvcChat.OnInviteFail = this.OnInviteFail;
    
    let config = {};  
    config.resolution = "540x960";
    config.fps = "20";
    config.maxBitrate = app.globalData.maxBitrate;
    config.tag = app.globalData.publish_tag;
    // 发布
    app.globalData.artvcChat.trace("[pushAndLive] publish start");
    this.pusherCtx = wx.createLivePusherContext('pusher');
    this.pusherCtx.startPreview();
    app.globalData.artvcChat.Publish(config);
    //订阅
    this.setData({
      muted: options.showAudio == "false" ? true : false,
      _uid: app.globalData.uid,
      feedIds: getApp().globalData.feedIds,
      minCache: getApp().globalData.minCache,
      maxCache: getApp().globalData.maxCache,
      minBitrate: getApp().globalData.minBitrate,
      maxBitrate: getApp().globalData.maxBitrate,
      roomId: getApp().globalData.roomId,
      rtoken: getApp().globalData.rtoken,
      cameraScore: '#7CCD7C',
      micScore: '#7CCD7C',
      cameraText: '关闭摄像头',
      micText: '关闭麦克风',
    }, () => {
      this.setData({
        showMedia:true
      })
    });
    if (this.data.feedIds.length) {
      app.globalData.artvcChat.Subscribe(this.data.feedIds[0].feedId)
    }

  },
  OnUnPublish(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] OnUnPublish ${data.feedId} `);
    delete this.data.listData.player[data.feedId];
    this.bindLiverStop(data.feedId);
    this.setData({
      "listData.player": this.data.listData.player
    });

  },
  OnGetTxtMessage(data) {
    let isRepeated = this.data.chatRecord.some(function (item) {
      return item.msgId == data.msgId;
    });
    if (isRepeated) return
    let obj = {};
    obj.myMessage = false;
    obj.msg = data.msg;
    obj.uid = data.uid;
    obj.msgId = data.msgId;
    this.data.chatRecord.push(obj);
    this.setData({
      chatRecord: this.data.chatRecord
    })
  },
  OnClientJoin(data) {
    //删除之前订阅加入失败的
    for (let i = this.data.feedIds.length - 1; i >= 0; i--) {
      if (this.data.feedIds[i].feedId == data.feedId) {
        this.data.feedIds.splice(i, 1)
      }
    }
    this.data.feedIds.push(data);
    this.setData({
      feedIds: this.data.feedIds
    });
    app.globalData.artvcChat.Subscribe(data.feedId);
  },
  OnLeaveRoom(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] OnLeaveRoom leaveType=${data.leaveType}`);
  },
  //对端离开房间通知
  OnParticipantLeaveRoom(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] OnParticipantLeaveRoom leaveType=${data.exitType}`);
    this.data.feedIds.forEach(item => {
      if(item.uid == data.participant) {
        delete this.data.listData.player[item.feedId];
        this.bindLiverStop(item.feedId);
      }
    })
    this.setData({
      "listData.player": this.data.listData.player
    })    
  },

  OnGetSign(bizName, subBiz, uid, workspaceId) {
    return getApp().globalData.sign;
  },

  // 处理收到websocket消息
  OnError(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] OnError data=${JSON.stringify(data)}`);
    let code = data.code;
    let msg = data.msg;
    wx.showModal({
      title: '小贴士',
      content: code + ": " + msg,
      confirmText: '确认',
      showCancel: false,
      success: (res) => { }
    })
  },

  // 处理收到websocket消息
  OnPublish(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] publish OnPublish data=${data.pushUrl}`);
    app.globalData.pushUrl = data.pushUrl;
    this.setData({
      pushURL: data.pushUrl
    });
  },
  // 处理收到websocket消息
  OnSubscribe(data) {
    app.globalData.artvcChat.trace(`[pushAndLive] subscribe OnSubscribe data=${data.liveUrl}`);
    // if(app.globalData.liveUrl.length <2){
    let feedIds = this.data.feedIds;
    let feedId = data.feedId;
    let player = this.data.listData.player;
    let currentClient;
    feedIds.forEach(item => {
      if (item.feedId == feedId) {
        item.liveUrl = data.liveUrl;
        item.feedId = data.feedId;
        currentClient = item;
      }
    })
    player[currentClient.feedId] = {};
    app.globalData.liveUrl.push(currentClient.liveUrl);
    this.data.liveURL.push(currentClient.liveUrl);
    this.setData({
      feedIds: feedIds,
      "listData.player": player
    });
    this.liverCtx[currentClient.feedId] = wx.createLivePlayerContext(currentClient.feedId);
    for (let i = 0; i < feedIds.length; i++) {
      let item = feedIds[i]
      if (!item.liveUrl) {
        app.globalData.artvcChat.Subscribe(item.feedId);
        return
      }
    }
  },
  OnUnsubscribe(streamId){
    console.log(streamId)
  },
  //离开房间
  leaveRoom: function () {
    
    app.globalData.artvcChat.LeaveRoom();
    app.globalData.feedIds = [];
    this.bindPusherStop();
    this.data.feedIds.forEach(item => {
      this.bindLiverStop(item.feedId);
    })
    app.globalData.artvcChat.Disconnect();
    wx.redirectTo({
      url: '../index/index'
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {
    app.globalData.artvcChat.trace("[pushAndLive] onReady");
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    const this_ = this
    app.globalData.artvcChat.trace("[pushAndLive] onShow");
    this.openCamera();
    // app.globalData.artvcChat.OnError = this.OnError;
    // 接电话是小程序被压后台，需手动重新启动推流
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.stop({
      success: res => {
        app.globalData.artvcChat.trace("[pushAndLive] pusher stop");
        this_.pusherCtx.start({
          success: res => {
            app.globalData.artvcChat.trace("[pushAndLive] pusher restart");
          }
        })
      }
    })
    // this.setData({
    //   pushURL: app.globalData.pushUrl,
    //   feedIds: this.data.feedIds
    // });
  },


  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {
    app.globalData.artvcChat.trace("[pushAndLive] onHide");
    this.closeCamera();
  },
  showChatRecord() {
    this.setData({
      showChat: !this.data.showChat
    })
  },
  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {
    //销毁房间 
    app.globalData.feedIds = [];
    this.bindPusherStop();
    this.data.feedIds.forEach(item => {
      this.bindLiverStop(item.feedId);
    })
    app.globalData.artvcChat.LeaveRoom();
    app.globalData.artvcChat.Disconnect();
    wx.reLaunch({
      url: '../index/index'
    })
  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {

  },

  //推流
  bindPusherStart() {
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.start({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherStart success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherStart fail');
      }
    })
  },

  bindPusherPause() {
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.pause({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherPause success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherPause fail');
      }
    })
  },

  bindPusherStop() {
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.stop({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherStop success');
        // this.bindPusherStart();
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherStop fail');
      }
    })
  },

  bindPusherResume() {
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.resume({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherResume success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherResume fail');
      }
    })
  },

  //切换摄像头
  bindPusherSwitchCamera() {
    if (!this.pusherCtx) {
      return;
    }
    this.pusherCtx.switchCamera({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherSwitchCamera success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindPusherSwitchCamera fail');
      }
    })
  },

  //开关摄像头
  bindEnableCamera() {
    if (this.data.enableCamera) {
      this.closeCamera();
    } else {
      this.openCamera();
    }
  },

  //打开摄像头
  openCamera() {
    this.setData({
      enableCamera: true,
      cameraScore: '#7CCD7C',
      cameraText: '关闭摄像头'
    });
  },

  //关闭摄像头
  closeCamera() {
    this.setData({
      enableCamera: false,
      cameraScore: '#BEBEBE',
      cameraText: '打开摄像头'
    });
    app.globalData.artvcChat.ReportClientEvent(321);
  },

  //开关麦克风
  bindEnableMic() {
    this.setData({
      muted: !this.data.muted,
      micScore: this.data.micScore == '#BEBEBE' ? '#7CCD7C' : '#BEBEBE',
      micText: this.data.micText == '关闭麦克风' ? '打开麦克风' : '关闭麦克风',
    });
    if (this.data.muted) {
      app.globalData.artvcChat.ReportClientEvent(323);
    } else {
      app.globalData.artvcChat.ReportClientEvent(324);
    }
  },


  //拉流
  bindLiverStart() {
    if (!this.liverCtx) {
      return;
    }
    this.liverCtx.play({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverStart success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverStart fail');
      }
    })
  },

  bindLiverPause() {
    if (!this.liverCtx) {
      return;
    }
    this.liverCtx.pause({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverPause success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverPause fail');
      }
    })
  },

  bindLiverStop(feedId) {
    if (!this.liverCtx[feedId]) {
      return;
    }
    this.liverCtx[feedId].stop({
      success: res => {
        for (let j = 0; j < this.data.feedIds.length; j++) {
          if (this.data.feedIds[j].feedId == feedId) {
            delete this.liverCtx[feedId]
            this.data.feedIds.splice(j, 1);
            this.setData({
              feedIds: this.data.feedIds
            })
          }
        }
        app.globalData.artvcChat.trace(`[pushAndLive] bindLiverStop ${feedId} success`);
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverStop fail');
      }
    })
  },
  bindLiverResume() {
    if (!this.liverCtx) {
      return;
    }
    this.liverCtx.resume({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverResume success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverResume fail');
      }
    })
  },

  bindLiverMute() {
    if (!this.liverCtx) {
      return;
    }
    this.liverCtx.mute({
      success: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverMute success');
      },
      fail: res => {
        app.globalData.artvcChat.trace('[pushAndLive] bindLiverMute fail');
      }
    })
  },

})
