// pages/join/join.js
// import ArtvcRoom from '/utils/ArtvcRoom.js';
import ArtvcRoom from '../../utils/ArtvcRoom.js';
const app = getApp()
Page({

    /**
     * 页面的初始数据
     */
    data: {
        // used to store user info like portrait & nickname
        userInfo: {},
        hasUserInfo: false,
        // whether to disable join btn or not
        disableJoin: false,
        showAudio: true,
        showVideo:true,
        publish_tag: app.globalData.publish_tag,
        roomId:"",
        rToken: ""
    },

    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function(options) {
        let userInfo = wx.getStorageSync("userInfo");
        if (userInfo) {
            this.setData({
                hasUserInfo: true,
                userInfo: userInfo
            });
        }

        this.artvcChat = new ArtvcRoom(this);
        app.globalData.artvcChat = this.artvcChat;
        let config = {};
        config.uid = app.globalData.uid;
        config.biz_name = app.globalData.bizName;
        config.appId = app.globalData.appId;
        config.workspaceId = app.globalData.workspaceId;
        config.server_url = app.globalData.server_url;
        // config.sign = app.globalData.sign;
        config.network_check_timeout = 10;
        app.globalData.artvcChat.Connect(config); //连接
        app.globalData.artvcChat.OnError = this.OnError;
        app.globalData.artvcChat.OnCreateRoom = this.OnCreateRoom;
        app.globalData.artvcChat.OnJoinRoom = this.OnJoinRoom;
        app.globalData.artvcChat.OnGetSign = this.OnGetSign;
        app.globalData.artvcChat.OnLeaveRoom = this.OnLeaveRoom;
        app.globalData.artvcChat.OnConnect = this.OnConnect;
        app.globalData.artvcChat.OnGetFeedIds = this.OnGetFeedIds;
        app.globalData.artvcChat.OnInviteRequest = this.OnInviteRequest;
        app.globalData.artvcChat.OnReplyInviteFail = this.OnReplyInviteFail;
        app.globalData.artvcChat.OnReplyInviteOK = this.OnReplyInviteOK;
        
    },
    OnConnect(data) {
        app.globalData.artvcChat.trace(`OnConnect data=${JSON.stringify(data)}`);
        wx.onAppShow(app.globalData.artvcChat.ReportClientEvent.bind(app.globalData.artvcChat,302))
        wx.onAppHide(app.globalData.artvcChat.ReportClientEvent.bind(app.globalData.artvcChat,301))
    },
  
    OnLeaveRoom(data) {
        app.globalData.artvcChat.trace(`OnLeaveRoom leaveType=${data.leaveType}`);
    },

    OnGetSign(bizName, appId, uid, workspaceId) {
        return getApp().globalData.sign;
    },

    // 处理收到websocket消息
    OnError(data) {
        console.log(`这是在 join 页面 onError 中收到的消息 data=${JSON.stringify(data)}`);
        let code = data.code;
        let msg = data.msg;
        wx.showModal({
            title: '小贴士',
            content: msg,
            confirmText: '确认',
            showCancel: false,
            success: (res) => {}
        })
    },

    // 处理收到websocket消息
    OnCreateRoom(data) {
        console.log(`这是在 room 页面 onCreateRoom 中收到的消息 data = ${JSON.stringify(data)}`);
        app.globalData.roomId = data.roomId;
        app.globalData.rtoken = data.rtoken;
        wx.navigateTo({
            url: '../pushAndlive/pushAndlive?showAudio=' + this.data.showAudio + '&showVideo=' + this.data.showVideo 
        })
    },
    // 获取所有FeedId
    OnGetFeedIds(data){
        app.globalData.feedIds = data;   
        wx.navigateTo({
            url: '../pushAndlive/pushAndlive?showAudio=' + this.data.showAudio + '&showVideo=' + this.data.showVideo 
        })
    },
    // 处理收到websocket消息
    OnJoinRoom(data) {
        console.log(`这是在 room 页面 onJoinRoom 中收到的消息 data =${JSON.stringify(data)}`);
    },
    OnInviteRequest(roomId, rtoken, inviter, extra, inviteId, inviteInfo) {
        const _this = this;
        wx.showModal({
            title: "邀请加入房间",
            content: "是否加入房间",
            success: function(e) {
                console.log(e)
                if(e.confirm) {
                    _this.roomId = roomId;
                    _this.token = rtoken;
                    _this.setData({
                        roomId:roomId,
                        rToken:rtoken
                    })
                    app.globalData.artvcChat.ReplyInviteToJoinRoom(roomId, inviter, 0, inviteId, inviteInfo);
                    _this.joinRoom()
                } else if (e.cancel) {
                    app.globalData.artvcChat.ReplyInviteToJoinRoom(roomId, inviter, 2, inviteId, inviteInfo);
                }
            }, 
            fail: function(){
            }
        })
    },
    OnReplyInviteOK(){
        console.log("回复邀请成功")
    },
    OnReplyInviteFail(code, msg){
        console.log(`回复邀请失败：错误代码${code},msg:${msg}`)
    },
    //创建房间
    onGotUserInfoCreate: function(e) {
        const _this = this;
        let userInfo = e.detail.userInfo || {};
        // store data for next launch use
        wx.setStorage({
            key: 'userInfo',
            data: userInfo,
        });
        wx.getSetting({
            success(res){
                if(res.authSetting['scope.camera'] == false){
                    wx.showToast({
                        title: '请打开摄像头权限',
                        icon: 'none',
                        duration: 2000
                    })
                    return
                }        
                //创建房间
                _this.setData({
                    showAudio:res.authSetting['scope.record'],
                    showVideo: res.authSetting['scope.camera']
                });
                app.globalData.artvcChat.CreateRoom();
            }
        })
        
    },

    /**
     * callback to get user info
     * using wechat open-type
     */
    onGotUserInfo: function(e) {
        let userInfo = e.detail.userInfo || {};
        const _this = this;

        // store data for next launch use
        wx.setStorage({
            key: 'userInfo',
            data: userInfo
        })
        wx.getSetting({
            success(res){
                if(res.authSetting['scope.camera'] == false){
                    wx.showToast({
                        title: '请打开摄像头权限',
                        icon: 'none',
                        duration: 2000
                    })
                    return
                }        
                //创建房间
                _this.setData({
                    showAudio:res.authSetting['scope.record'],
                    showVideo: res.authSetting['scope.camera']
                });
                _this.joinRoom();
            }
        })
        
    },
    bindOpenSetting(e){
        app.globalData.authority = e.detail.authSetting
    },
    onInputChannel: function(e) {
        let value = e.detail.value;
        this.roomId = value;
        this.setData({
            roomId:value
        })
    },

    onInputChannelToken: function(e) {
        let token = e.detail.value;
        this.token = token;
        this.setData({
            rToken:token
        })
    },
    onGetPublishTag(e) {
        this.setData({
            publish_tag:e.detail.value
        }, () => {
            app.globalData.publish_tag = e.detail.value;
        })
    },

    //加入房间
    joinRoom: function() {
        let roomId = this.roomId;
        let rtoken = this.token;
        app.globalData.roomId = roomId;
        app.globalData.rtoken = rtoken;
        if (!roomId || !rtoken) {
            wx.showToast({
                title: '请提供一个有效的房间名和房间密码',
                icon: 'none',
                duration: 2000
            })
        } else {
            //加入房间
            let config = {};
            config.roomId = roomId;
            config.rtoken = rtoken;
            app.globalData.artvcChat.JoinRoom(config);
        }
    },

    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function() {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function() {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function() {

    },


    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function() {
        app.globalData.artvcChat.Disconnect();
    },


    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function() {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function() {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function() {

    }

})